%define debug_package %{nil}

%define python2_sitelib %(python2 -c   "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=True)")
%define python3_sitelib %(python3 -Esc "from distutils.sysconfig import get_python_lib; print(get_python_lib(True))")

%if 0%{?fedora} || 0%{?centos} >= 7
%global         with_python3 1
%else
%global         with_python3 0
%endif

Summary:	distorm3 - binary stream disassembler library 

Packager:	Lawrence R. Rogers (lrr@cert.org)

Vendor:		cert.org
Name:		distorm3
Version:	3.4.1
Release:	2%{?dist}
URL:		https://github.com/gdabah/distorm

License:	GPL

Group:		Applications/Forensics Tools
Source:		%{name}-%{version}.zip

BuildRoot:	%{_tmppath}/rpm-root-%{name}-v%{version}

%description
diStorm is a lightweight, easy-to-use and fast decomposer library.  It disassembles instructions
in 16, 32 and 64 bit modes.  Supported instruction sets: FPU, MMX, SSE, SSE2, SSE3, SSSE3,
SSE4, 3DNow! (w/ extensions), new x86-64 instruction sets, VMX, AMD's SVM and AVX!

%package -n python2-%{name}
Summary:	Binary stream disassembler library for Python2
BuildRequires:	python2-devel
Obsoletes:	%{name}
Provides:	%{name} = %{version}
Provides:	python-%{name} = %{version}

%description -n python2-%{name}
diStorm is a lightweight, easy-to-use and fast decomposer library.  It disassembles instructions
in 16, 32 and 64 bit modes.  Supported instruction sets: FPU, MMX, SSE, SSE2, SSE3, SSSE3,
SSE4, 3DNow! (w/ extensions), new x86-64 instruction sets, VMX, AMD's SVM and AVX!

%if 0%{?with_python3}
%package -n python%{python3_pkgversion}-%{name}
Summary:        Binary stream disassembler library for Python2
BuildRequires:  python%{python3_pkgversion}-devel
Provides:       python%{python3_pkgversion}-%{name} = %{version}
%if 0%{?centos} == 7
Provides:	python36-%{name} = %{version}
%endif

%description -n python%{python3_pkgversion}-%{name}
diStorm is a lightweight, easy-to-use and fast decomposer library.  It disassembles instructions
in 16, 32 and 64 bit modes.  Supported instruction sets: FPU, MMX, SSE, SSE2, SSE3, SSSE3,
SSE4, 3DNow! (w/ extensions), new x86-64 instruction sets, VMX, AMD's SVM and AVX!
%endif

%prep
%setup

%build
%py2_build
%if 0%{?with_python3}
%py3_build
%endif

%install
%py2_install
%if 0%{?with_python3}
%py3_install
%endif

%clean
%{__rm} -rf %{buildroot}

%files -n python2-%{name}
%defattr(0644, root, root, 0755)
%doc COPYING
%{python2_sitelib}/%{name}*

%if 0%{?with_python3}
%files -n python%{python3_pkgversion}-%{name}
%defattr(-, root, root, 0755)
%doc COPYING
%{python3_sitelib}/%{name}*
%endif

%changelog
* Thu Oct 24 2019 Lawrence R. Rogers <lrr@cert.org> 3.4.1-2
* Release 3.4.1-2
	Added python3 version

* Tue Jan 15 2019 Lawrence R. Rogers <lrr@cert.org> 3.4.1-1
* Release 3.4.1-1
	Version 3.4.1.

* Sat Jun  4 2016 Lawrence R. Rogers <lrr@cert.org> 3.3.4-1
* Release 3.3.4-1
	Version 3.3.4.

* Wed Nov 18 2015 Lawrence R. Rogers <lrr@cert.org> 3.1-1
* Release 3.1-1
	This is distorm3 version 3.1 that has been installed to solve this problem: https://code.google.com/p/volatility/issues/detail?id=342
	Distorm3 version 3.3 is available but it has a problem in Volatility.

* Sat Jan 03 2015 Lawrence R. Rogers <lrr@cert.org> 3.0-1
* Release 3.0-1
	See the changes here: https://code.google.com/p/distorm/source/list

* Sun Sep 30 2012 Lawrence R. Rogers <lrr@cert.org> 3-2
* Release 3-2
	Fixed a text formatting problem with the MOVZX instruction, thanks to Jun Koi for reporting.

	Finally I got to fix the problem with the Python binding. I also had to fix a few other problems.
	I am testing everything and will upload a new version by tomorrow. Thanks for your patience.

* Sun Jul 29 2012 Lawrence R. Rogers <lrr@cert.org> 3-1
* Release 3-1
	diStorm version 3.3 is now released. The structure of a decoded instruction now contains new fields
	that let one know how the instruction affected the CPU flags (modified, tested, undefined). For
	more info see the last three fields of the DInst structure inside DecomposeInterface.

	Compacted the DB of instructions much more, with another level of shared data among similar instructions...

	The Python bindings now support the control flow features that diStorm3 itself support, thanks to Vext01.

* Mon Apr 9 2012 Lawrence R. Rogers <lrr@cert.org> 2-1
* Release 2-1
	A major release of diStorm3.2 is now available. Fixed many instructions, either operand accuracy
	problems or typos in mnemonics. Fixed a few bugs introduced in July 2011. Added new instructions
	such as: INVPCID, TZCNT, RDxSBASE, WRxSBASE, CVTPS2PH, CVTPH2PS and more. Added a new compiler
	directive DISTORM_LIGHT to compile only distorm_decompose (no text formatting) to make diStorm
	smaller in size (should save around 20kb), thanks to Marius Negrutiu of BullGuard. Fixed the
	Java wrapper to support latest version.


* Sat Jul 2 2011 Lawrence R. Rogers <lrr@cert.org> 1.0-1
* Release 1.0-1
	Initial release
